javax.transaction

## Annotation Type Transactional

-     @Inherited
      @InterceptorBinding
      @Target(value={TYPE,METHOD})
      @Retention(value=RUNTIME)
      public @interface Transactional

  The javax.transaction.Transactional annotation provides the application the ability to declaratively control transaction boundaries on CDI managed beans, as well as classes defined as managed beans by the Java EE specification, at both the class and method level where method level annotations override those at the class level.

  See the EJB specification for restrictions on the use of @Transactional with EJBs.

  This support is provided via an implementation of CDI interceptors that conduct the necessary suspending, resuming, etc. The Transactional interceptor interposes on business method invocations only and not on lifecycle events. Lifecycle methods are invoked in an unspecified transaction context.

  If an attempt is made to call any method of the UserTransaction interface from within the scope of a bean or method annotated with @Transactional and a Transactional.TxType other than NOT_SUPPORTED or NEVER, an IllegalStateException must be thrown. The use of the UserTransaction is allowed within life cycle events. The use of the TransactionSynchronizationRegistry is allowed regardless of any @Transactional annotation.

  The Transactional interceptors must have a priority of Interceptor.Priority.PLATFORM_BEFORE+200. Refer to the Interceptors specification for more details.

  The TxType element of the annotation indicates whether a bean method is to be executed within a transaction context. TxType.REQUIRED is the default.

  By default checked exceptions do not result in the transactional interceptor marking the transaction for rollback and instances of RuntimeException and its subclasses do. This default behavior can be modified by specifying exceptions that result in the interceptor marking the transaction for rollback and/or exceptions that do not result in rollback.

  The rollbackOn element can be set to indicate exceptions that must cause the interceptor to mark the transaction for rollback.

  Conversely, the dontRollbackOn element can be set to indicate exceptions that must not cause the interceptor to mark the transaction for rollback.

  When a class is specified for either of these elements, the designated behavior applies to subclasses of that class as well. If both elements are specified, dontRollbackOn takes precedence.

  Since:
    JTA1.2

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `Class[]` | `dontRollbackOn` The dontRollbackOn element can be set to indicate exceptions that must not cause the interceptor to mark the transaction for rollback.
    `Class[]` | `rollbackOn` The rollbackOn element can be set to indicate exceptions that must cause the interceptor to mark the transaction for rollback.
    `Transactional.TxType` | `value` The TxType element of the Transactional annotation indicates whether a bean method is to be executed within a transaction context.

- - ### Element Detail

    - #### value

          public abstract Transactional.TxType value

      The TxType element of the Transactional annotation indicates whether a bean method is to be executed within a transaction context.
      Default:
        javax.transaction.Transactional.TxType.REQUIRED

    - #### rollbackOn

          public abstract Class[] rollbackOn

      The rollbackOn element can be set to indicate exceptions that must cause the interceptor to mark the transaction for rollback. Conversely, the dontRollbackOn element can be set to indicate exceptions that must not cause the interceptor to mark the transaction for rollback. When a class is specified for either of these elements, the designated behavior applies to subclasses of that class as well. If both elements are specified, dontRollbackOn takes precedence.
      Returns:
        Class[] of Exceptions
      Default:
        {}

    - #### dontRollbackOn

          public abstract Class[] dontRollbackOn

      The dontRollbackOn element can be set to indicate exceptions that must not cause the interceptor to mark the transaction for rollback. Conversely, the rollbackOn element can be set to indicate exceptions that must cause the interceptor to mark the transaction for rollback. When a class is specified for either of these elements, the designated behavior applies to subclasses of that class as well. If both elements are specified, dontRollbackOn takes precedence.
      Returns:
        Class[] of Exceptions
      Default:
        {}

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.